<?php
if ($_SERVER['SERVER_ADDR'] != '127.0.0.1') {
    die('Direct access not permitted');
}
// This script will output a 123solar counter into a meterN compatible format
// You'll need to setup the path to 123, your inverter number and your meter id
// Request live command with "curl http://localhost/metern/comapps/pool123solar.php?cmd=1"
// Main command with "curl http://localhost/metern/comapps/pool123solar.php?cmd=2"

$pathto123s = '/srv/http/123solar';
$invtnum    = 1;
$meterid    = 4;

// No edit is needed below
if (!empty($_GET['cmd']) && is_numeric($_GET['cmd'])) {
    $cmd = $_GET['cmd'];
}

define('checkaccess', TRUE);
include("$pathto123s/config/config_main.php");
include("$pathto123s/config/config_invt$invtnum.php");
include("$pathto123s/scripts/memory.php");

date_default_timezone_set($DTZ);

$KWHT = 0;
@$shmid = shmop_open($LIVEMEMORY, 'a', 0, 0);
if (!empty($shmid)) {
$size = shmop_size($shmid);
shmop_close($shmid);

	@$shmid = shmop_open($LIVEMEMORY, 'c', 0644, $size);
	if (!empty($shmid)) {
	    $data = shmop_read($shmid, 0, $size);
	    shmop_close($shmid);
	    $memarray = json_decode($data, true);
	    
	    if ($cmd == 1) {
		$nowUTC = strtotime(date("Ymd H:i:s"));
		if ($nowUTC - $memarray["SDTE$invtnum"] < 30) {
		    $GP = $memarray["G1P$invtnum"] + $memarray["G2P$invtnum"] + $memarray["G3P$invtnum"];
		    if ($GP > 1000) {
		        $GP = round($GP, 0);
		    } else {
		        $GP = round($GP, 1);
		    }
		} else { // Too old
		    $GP = 0;
		}
	    } else {
		$KWHT = round(($memarray["KWHT$invtnum"] * ${'CORRECTFACTOR' . $invtnum} * 1000), 0); //in Wh    
	    }
	}
}

if ($cmd != 1 && (empty($shmid) || $KWHT == 0)) { // 123s ain't running at night retrieve the value in csv
    $dir    = $pathto123s . '/data/invt' . $invtnum . '/csv';
    $output = glob($dir . "/*.csv");
    sort($output);
    $xdays = count($output);
    if ($xdays > 1) {
        $lastlog    = $output[$xdays - 1];
        $lines      = file($lastlog);
        $contalines = count($lines);
        $array_last = preg_split('/,/', $lines[$contalines - 1]);
        $KWHT       = round(($array_last[27] * ${'CORRECTFACTOR' . $invtnum} * 1000), 0); //in Wh
    } else {
        $KWHT = 0;
    }
}

if ($cmd == 1 && empty($shmid)) { // 123s ain't running
    $GP = 0;
}

if ($cmd == 1) {
    echo "$meterid($GP*W)\n";
} else{
    echo "$meterid($KWHT*Wh)\n";
}
?>
