<?php
include('styles/globalheader.php');
include('config/config_main.php');

if (!empty($_POST['date1'])) {
    $date1 = $_POST['date1'];
}
$grid = array();

for ($i = 1; $i <= $NUMMETER; $i++) {
    include("config/config_met$i.php");
    if (!empty($_POST["check$i"])) {
        $check[$i] = $_POST["check$i"];
    } else {
        $check[$i] = 'off';
    }
    
    if (${'TYPE' . $i} == 'Elect' && ${'PROD' . $i} != 0 && !isset($grid[${'PHASE' . $i}])) {
        $grid[${'PHASE' . $i}] = ${'PHASE' . $i};
    }
}

sort($grid);
$cnt   = count($grid);
$sscnt = 0;
$efcnt = 0;

for ($i = 0; $i < $cnt; $i++) {
    if (!empty($_POST["ss$i"])) {
        $ss[$i] = $_POST["ss$i"];
        if ($ss[$i] != 0) {
            $selfsuff[$sscnt] = $ss[$i];
            $sscnt++;
        }
    } else {
        $ss[$i] = 0;
    }
    if (!empty($_POST["ef$i"])) {
        $ef[$i] = $_POST["ef$i"];
        if ($ef[$i] != 0) {
            $energf[$efcnt] = $ef[$i];
            $efcnt++;
        }
    } else {
        $ef[$i] = 0;
    }
}

if (ereg("([0-9]{2})/([0-9]{2})/([0-9]{4})", $date1)) { // test date1 
    
    $titledate = substr($date1, 0, 10);
    $date1     = (substr($date1, 6, 4)) . (substr($date1, 3, 2)) . (substr($date1, 0, 2)) . ".csv";
?>
<script type="text/javascript">

$(document).ready(function()
{
Highcharts.setOptions({
global: {
useUTC: true
},
lang: {
decimalPoint: '<?php
    echo $DPOINT;
?>',
thousandsSep: '<?php
    echo $THSEP;
?>'
}
});

var Mychart, options = {
chart: {
renderTo: 'container',
backgroundColor: null,
zoomType: 'xy',
resetZoomButton: {
                position: {
                    align: 'right',
                    verticalAlign: 'top'
                }
},
loading: {
 labelStyle: { top: '45%' },
 style: { backgroundColor: null }
},
spaceRight:20
},
credits: {enabled: false},
<?php
    echo "
subtitle: { text: '$lgDETAILSUBTITLE' },
xAxis: {
type: 'datetime',
minRange: 300000,
dateTimeLabelFormats: {minute: '%H:%M'}
},
yAxis: [";
    $yaxislist = array();
    for ($i = 1; $i <= $NUMMETER; $i++) {
        if ($check[$i] == 'on') {
            if (!in_array(${'UNIT' . $i}, $yaxislist)) {
                array_push($yaxislist, ${'UNIT' . $i});
            }
        }
    }
    if ($sscnt > 0) {
        array_push($yaxislist, '%');
    }
    if ($efcnt > 0 && !in_array('Wh', $yaxislist)) {
        array_push($yaxislist, 'Wh');
    }
    $conta = count($yaxislist);
    $conta--;
    for ($i = 0; $i <= $conta; $i++) {
        echo "{
  labels: { formatter: function() { return this.value +'$yaxislist[$i]';}},
  title: { text: '$yaxislist[$i]'}
  }";
        if ($i != $conta) {
            echo ',';
        }
    }
    echo "],
tooltip: {
formatter: function() {
";
    for ($i = 1; $i <= $NUMMETER; $i++) {
        settype(${'PRECI' . $i}, 'integer');
        if ($i == 1) {
            echo "if";
        } else {
            echo " else if";
        }
        echo "(this.series.name=='${'METNAME'.$i}') {
return '<b>' + Highcharts.numberFormat(this.y,'${'PRECI'.$i}') + '${'UNIT'.$i} </b><br/>' + Highcharts.dateFormat('%H:%M', this.x)
}";
    }
    for ($i = 0; $i < $sscnt; $i++) {
        echo " else if (this.series.name=='$lgSELFS$selfsuff[$i]') {
return '<b>' + Highcharts.numberFormat(this.y,'1') + '%</b><br/>' + Highcharts.dateFormat('%H:%M', this.x)
}";
    }
    for ($i = 0; $i < $efcnt; $i++) {
        echo " else if (this.series.name=='$lgENERGYF$energf[$i]') {
return '<b>' + Highcharts.numberFormat(this.y,'0') + 'Wh</b><br/>' + Highcharts.dateFormat('%H:%M', this.x)
}";
    }
    echo "else {return '<b>' + Highcharts.numberFormat(this.y,'1') + '</b><br/>' + Highcharts.dateFormat('%H:%M', this.x)
}
}
},
legend: {
layout: 'horizontal',
align: 'center',
floating: false,
backgroundColor: '#FFFFFF'
},
plotOptions: {
 areaspline: {
 fillOpacity: 0.3
 }
},
exporting: {
filename: 'meterN-chart',
width: 1200
},
series: []
};
"; // End of echo
    
    // transmit the value to proceed them via _GET
    echo "
var date1 = '$date1'
";
    for ($i = 1; $i <= $NUMMETER; $i++) {
        echo "var check$i = '$check[$i]'
";
    }
    
    for ($i = 0; $i < $cnt; $i++) {
        echo "var ss$i = '$ss[$i]'
	 var ef$i = '$ef[$i]'
	 
";
    }
    
    echo "
Mychart= new Highcharts.Chart(options);
Mychart.showLoading();
  $.getJSON('programs/programdetailed.php', {date1: date1";
    for ($i = 0; $i < $cnt; $i++) {
        echo ",ss$i:$ss[$i],ef$i:$ef[$i]";
    }
    for ($i = 1; $i <= $NUMMETER; $i++) {
        echo ",check$i:check$i";
    }
    echo "}, function(JSONResponse) 
{
options.series = JSONResponse.data;
Mychart= new Highcharts.Chart(options);
Mychart.setTitle({text: JSONResponse.title});
Mychart.hideLoading();
});
 
});
</script>
"; //End of echo
} // End of date valid
echo "
<div align='center'>
<div id='container' style='width: 100%; height: 550px'></div>
<br>&nbsp;
<FORM method='POST' action='detailed.php'>";
$year    = substr($date1, 0, 4);
$month   = substr($date1, 4, 2);
$day     = substr($date1, 6, 2);
$date1   = strtotime("$year-$month-$day");
$prevday = $date1 - 86400;
$nextday = $date1 + 86400;
$prevday = date('d/m/Y', $prevday);
$nextday = date('d/m/Y', $nextday);
for ($i = 1; $i <= $NUMMETER; $i++) {
    echo "<input type='hidden' name='check$i' value='$check[$i]'> ";
}
for ($i = 0; $i < $cnt; $i++) {
	echo "<input type='hidden' name='ss$i' value='$ss[$i]'> ";
	echo "<input type='hidden' name='ef$i' value='$ef[$i]'> ";
}
echo "
<button type='submit' name='date1' value='$prevday'> < </button>
<INPUT type='button' value='$lgBACK' OnClick=\"window.location.href='indexdetailed.php'\">
<button type='submit' name='date1' value='$nextday'> > </button>
</FORM>
</div>";
include("styles/default/footer.php");
?>
