<?php
// Credit Louviaux Jean-Marc 2014
include('loadcfg.php');
while (true) { // To infinity ... and beyond!
    for ($metnum = 1; $metnum <= $NUMMETER; $metnum++) { // Meters/Sensors pooling
        ///// Main memory
        $shmid = shmop_open($MEMORY, 'a', 0, 0);
        $size  = shmop_size($shmid);
        shmop_close($shmid);
        
        $shmid        = shmop_open($MEMORY, 'c', 0644, $size);
        $memarraydata = shmop_read($shmid, 0, $size);
        shmop_close($shmid);
        $memarray = json_decode($memarraydata, true);
        
        ///// Live memory
        $shmid = shmop_open($LIVEMEMORY, 'a', 0, 0);
        $size  = shmop_size($shmid);
        shmop_close($shmid);
        
        $shmid = shmop_open($LIVEMEMORY, 'c', 0644, $size);
        $data  = shmop_read($shmid, 0, $size);
        shmop_close($shmid);
        $livememarray = json_decode($data, true);
        /////
        
        $regexp = "/^${'LID'.$metnum}\([0-9\.]+\*[A-z0-9%]+\)$/i"; //LID(VALUE*UNIT)
        if (${'SKIPMONITORING' . $metnum} == false && ${'LIVEPOOL' . $metnum} != 0) {
            $datareturn = exec(${'LIVECOMMAND' . $metnum});
            $datareturn = trim($datareturn);
            if (preg_match($regexp, $datareturn)) {
                $datareturn = preg_replace("/^${'LID'.$metnum}\(/i", '', $datareturn, 1); // VALUE*UNIT)
                $val        = preg_replace("/\*[A-z0-9]+\)$/i", '', $datareturn, 1); // VALUE
                //settype($val, 'float');
            } else {
                $val = 0;
            }
        } else {
            $val = 0;
        }
        
        $livememarray['UTC']                         = strtotime(date('Ymd H:i:s'));
        $livememarray["${'METNAME'.$metnum}$metnum"] = $val; // Live value or state
        
        $minute   = date('i');
        $fiveflag = (bool) $memarray['5minflag'];
        
        if (in_array($minute, $minlist) && !$memarray['5minflag']) { // 5 min jobs
            $memarray['5minflag'] = true;
            
            for ($i = 1; $i <= $NUMMETER; $i++) { // For each meters
                $regexp     = "/^${'ID'.$i}\([0-9\.]+\*[A-z0-9%]+\)$/i"; //ID(VALUE*UNIT)
                $datareturn = '';
                $matches    = array();
                $giveup     = 0;
                
                if (${'SKIPMONITORING' . $i} == false) {
                    while (preg_match($regexp, $datareturn, $matches) != 1 && $giveup < 3) { // Try 3 times
                        $datareturn = exec(${'COMMAND' . $i});
                        $datareturn = trim($datareturn);
                        $giveup++;
                    }
                    if (preg_match($regexp, $datareturn)) {
                        $datareturn = preg_replace("/^${'ID'.$i}\(/i", '', $datareturn, 1); // VALUE*UNIT)
                        $lastval    = preg_replace("/\*[A-z0-9]+\)$/i", '', $datareturn, 1); // VALUE
                        settype($lastval, 'float');
                    } else {
                        $lastval = null;
                    }
                } else {
                    $lastval = null;
                }
                if ($i == 1) {
                    $PCtime     = date('H:i');
                    $stringData = "$PCtime";
                }
                $stringData .= ",$lastval";
                
                if (${'TYPE' . $i} != 'Sensor') {
                    $memarray["Totalcounter$i"] = $lastval;
                }
            } // For each meters
            
            $stringData .= "\r\n";
            $today  = date('Ymd');
            $myFile = $DATADIR . "/csv/$today.csv";
            file_put_contents($myFile, $stringData, FILE_APPEND);
            $lines      = file($myFile);
            $contalines = count($lines);
            
            if ($contalines > 2) {
                for ($i = 1; $i <= $NUMMETER; $i++) { // Consumption/production sensor check
                    $mailflag = (bool) $memarray["Mailflag$i"];
                    if ($mailflag == false) {
                        $array_first = preg_split('/,/', $lines[1]);
                        $array_last  = preg_split('/,/', $lines[$contalines - 1]);
                        $val_last    = array();
                        
                        $val_first    = trim($array_first[$i]);
                        $val_last[$i] = trim($array_last[$i]);
                        
                        if (!empty($val_first) && !empty($val_last[$i])) {
                            settype($val_first, 'float');
                            settype($val_last[$i], 'float');
                            
                            if (${'TYPE' . $i} != 'Sensor') { // Meter
                                if ($val_first <= $val_last[$i]) {
                                    $val_last[$i] -= $val_first;
                                } else { // counter pass over
                                    $val_last[$i] += ${'PASSO' . $i} - $val_first;
                                }
                            }
                            
                            if ($val_last[$i] > ${'WARNCONSOD' . $i} && ${'WARNCONSOD' . $i} != 0 && ${'SKIPMONITORING' . $i} == false) {
                                
                                $memarray["Mailflag$i"] = true;
                                
                                if (${'PROD' . $i} == 1) {
                                    $prodconsu = 'Production';
                                } elseif (${'PROD' . $i} == 2) {
                                    $prodconsu = 'Consumption';
                                } else {
                                    $prodconsu = '';
                                }
                                
                                $msg = "$prodconsu reach $val_last[$i] ${'UNIT'.$i}";
                                mail("${'EMAIL'.$i}", "meterN: ${'METNAME'.$i} $prodconsu warning", $msg);
                                if (${'PUSHO' . $i} == 1) {
                                    $pushover = exec('curl -s -F "title=' . ${'METNAME' . $i} . ' Warning" -F "token=BCZigaCQktVT4zR1xmpZ3iXsmkbm59" -F "user=' . ${'POUKEY' . $i} . '" -F "message=' . $msg . '" https://api.pushover.net/1/messages.json &');
                                }
                            }
                        }
                    }
                } // Consumption/prod check
            }
            
            if ($contalines == 1) { // Midnight
                $maitosend = false;
                $file      = $DATADIR . "/csv/$today.csv";
                
                $header = "Time";
                for ($i = 1; $i <= $NUMMETER; $i++) {
                    $header .= ",${'METNAME'.$i}(${'UNIT'.$i})";
                }
                $header .= "\r\n";
                
                $old_lignes = file($DATADIR . "/csv/$today.csv");
                array_unshift($old_lignes, $header);
                $new_content = implode('', $old_lignes);
                $fp          = fopen($file, 'w');
                fwrite($fp, $new_content);
                fclose($fp);
                
                $dir    = $DATADIR . '/csv';
                $output = glob($dir . "/*.csv");
                sort($output);
                $xdays = count($output);
                
                if ($xdays > 1) {
                    $yesterdaylog = $output[$xdays - 2]; // Yesterday consumption
                    $lines        = file($yesterdaylog);
                    $contalines   = count($lines);
                    
                    $array_first = preg_split('/,/', $lines[1]);
                    $array_last  = preg_split('/,/', $lines[$contalines - 1]);
                    
                    $date1 = substr($output[$xdays - 2], -8, 4);
                    $year  = (int) substr($output[$xdays - 2], -12, 4); // For new year
                    
                    for ($i = 1; $i <= $NUMMETER; $i++) {
                        if (${'TYPE' . $i} != 'Sensor') {
                            $val_first    = trim($array_first[$i]);
                            $val_last[$i] = trim($array_last[$i]);
                            
                            if (!empty($val_first) && !empty($val_last[$i])) {
                                settype($val_last[$i], 'float');
                                settype($val_first, 'float');
                                
                                if ($val_first <= $val_last[$i]) {
                                    $val_last[$i] -= $val_first;
                                } else { // counter pass over
                                    $val_last[$i] += ${'PASSO' . $i} - $val_first;
                                }
                            } else {
                                $val_last[$i] = 0;
                            }
                            $stringData = "$date1";
                            $stringData .= ",$val_last[$i]\r\n";
                            $myFile = $DATADIR . '/meters/' . $i . ${'METNAME' . $i} . $year . '.csv';
                            file_put_contents($myFile, $stringData, FILE_APPEND);
                        }
                    }
                    $msg = '';
                    
                    for ($i = 1; $i <= $NUMMETER; $i++) {
                        $memarray["Mailflag$i"] = false; // clear Mailflag
                        if (${'REPORT' . $i} == 'daily') { // Daily report
                            $month        = (int) substr($date1, 0, 2);
                            $day          = (int) substr($date1, 2, 2);
                            $date1        = date($DATEFORMAT, mktime(0, 0, 0, $month, $day, $year));
                            $val_last[$i] = round($val_last[$i], ${'PRECI' . $i});
                            $msg          = "${'METNAME'.$i} $val_last[$i] ${'UNIT'.$i}\r\n";
                            mail("${'EMAIL'.$i}", "meterN: $date1 report", $msg);
                        }
                    }
                    
                    for ($i = 1; $i <= $NUMMETER; $i++) {
                        $day1 = date('d');
                        if ($day1 == '01' && ${'REPORT' . $i} == 'monthly') { // Monthly report
                            $maitosend = true;
                            
                            $y_year     = date('Y', time() - 60 * 60 * 24); // yesterday
                            $y_month    = date('m', time() - 60 * 60 * 24);
                            $myFile     = file($DATADIR . '/meters/' . $i . ${'METNAME' . $i} . $y_year . '.csv');
                            $contalines = count($myFile);
                            $j          = 0;
                            for ($line_num = 0; $line_num < $contalines; $line_num++) {
                                $array = preg_split('/,/', $myFile[$line_num]);
                                $month = substr($array[0], 0, 2);
                                if ($month == $y_month) {
                                    $month         = substr($array[0], 0, 2);
                                    $day           = substr($array[0], 2, 2);
                                    $dayname[$j]   = date($DATEFORMAT, mktime(0, 0, 0, $month, $day, $y_year));
                                    $conso_day[$j] = $array[1];
                                    //settype($conso_day[$j], 'float');
                                    $conso_day[$j] = round($conso_day[$j], ${'PRECI' . $i});
                                    $j++;
                                }
                            }
                            $conso_month[$i] = round(array_sum($conso_day), ${'PRECI' . $i});
                        }
                        if ($maitosend == true) {
                            $maitosend = false;
                            $cnt       = count($dayname);
                            $msg       = "${'METNAME'.$i}\t (${'UNIT'.$i})\r\n";
                            for ($j = 0; $j < $cnt; $j++) {
                                $msg .= "$dayname[$j]\t";
                                $msg .= "$conso_day[$j]\r\n";
                            }
                            $msg .= "\r\n";
                            $msg .= "$conso_month[$i] ${'UNIT'.$i} on $y_month $y_year\r\n---\r\n";
                            mail("${'EMAIL'.$i}", "meterN: ${'METNAME'.$i} Monthly $y_month report", $msg);
                        }
                    }
                }
                // Morning cleanup
                if ($KEEPDDAYS != 0) {
                    if ($xdays > $KEEPDDAYS) {
                        $i = 0;
                        while ($i < $xdays - $KEEPDDAYS) {
                            unlink($output[$i]);
                            $i++;
                        }
                    }
                }
            } // End Midnight
        } // 5 min 
        
        
        if (!in_array($minute, $minlist) && $memarray['5minflag']) { // Run once every 1,6,11,16,..
            $memarray['5minflag'] = false; // Reset 5minflag
        }
        
        $data = json_encode($memarray);
        if ($data != $memarraydata) { // Reduce write
            $size  = mb_strlen($data, 'UTF-8');
            $shmid = shmop_open($MEMORY, 'a', 0, 0);
            shmop_delete($shmid);
            shmop_close($shmid);
            
            $shmid = shmop_open($MEMORY, 'c', 0644, $size);
            shmop_write($shmid, $data, 0);
            shmop_close($shmid);
        }
        
        $data = json_encode($livememarray);
        $size = mb_strlen($data, 'UTF-8');
        
        @$shmid = shmop_open($LIVEMEMORY, 'a', 0, 0);
        if (!empty($shmid)) {
            shmop_delete($shmid);
            shmop_close($shmid);
        }
        
        $shmid = shmop_open($LIVEMEMORY, 'c', 0644, $size);
        shmop_write($shmid, $data, 0);
        shmop_close($shmid);
    } // End meters pooling
    usleep($DELAY);
} // infinity
?>
